library CANxx;

uses
//  unitMemory in 'unitMemory.pas',
  SysUtils,
  Classes,
  Windows,
  Forms, ExtCtrls, Messages;

  {$imagebase $12400000}

type FT_Result = Integer;

type
 TonTimer = object
  procedure OnTimer(o: TObject);
end;

Var
// Port Handle Returned by the Open Function
// Used by the Subsequent Function Calls
    FT_HANDLE : DWord = 0;
// Used to handle multiple device instances in future
// versions. Must be set to 0 for now.
    PV_Device : DWord = 0;
// Holding Variables for the current settings
// Can be configured visually using the CFGUnit Unit
// or manually before calling SetUp_USB_Device
    FT_Current_Baud : Dword;
    FT_Current_DataBits : Byte;
    FT_Current_StopBits : Byte;
    FT_Current_Parity : Byte;
    FT_Current_FlowControl : Word;
    FT_Event_On : Boolean;
    FT_Error_On : Boolean;
    FT_XON_Value : Byte = $11;
    FT_XOFF_Value : Byte = $13;
    FT_EVENT_Value : Byte = $0;
    FT_ERROR_Value : Byte = $0;
// Used by CFGUnit to flag a bad value
    FT_SetupError : Boolean;
// Used to Return the current Modem Status
    FT_Modem_Status : DWord;
// Used to return the number of bytes pending
// in the Rx Buffer Queue
    FT_Q_Bytes : DWord;
// Used to Enable Disable the Error Report Dialog
    FT_Enable_Error_Report : Boolean = True;

Const
// FT_Result Values
    FT_OK = 0;
    FT_INVALID_HANDLE = 1;
    FT_DEVICE_NOT_FOUND = 2;
    FT_DEVICE_NOT_OPENED = 3;
    FT_IO_ERROR = 4;
    FT_INSUFFICIENT_RESOURCES = 5;
    FT_INVALID_PARAMETER = 6;
    FT_NONE = 10;
    FT_SUCCESS = FT_OK;
// FT_Notifications Events
    FT_EVENT_RXCHAR = 1;
    FT_EVENT_MODEM_STATUS = 2;
// FT_Open_Ex Flags
    FT_OPEN_BY_SERIAL_NUMBER = 1;
    FT_OPEN_BY_DESCRIPTION = 2;
// FT_List_Devices Flags
    FT_LIST_NUMBER_ONLY = $80000000;
    FT_LIST_BY_INDEX = $40000000;
    FT_LIST_ALL = $20000000;
// Baud Rate Selection
    FT_BAUD_300 = 300;
    FT_BAUD_600 = 600;
    FT_BAUD_1200 = 1200;
    FT_BAUD_2400 = 2400;
    FT_BAUD_4800 = 4800;
    FT_BAUD_9600 = 9600;
    FT_BAUD_14400 = 14400;
    FT_BAUD_19200 = 19200;
    FT_BAUD_38400 = 38400;
    FT_BAUD_57600 = 57600;
    FT_BAUD_115200 = 115200;
    FT_BAUD_230400 = 230400;
    FT_BAUD_460800 = 460800;
    FT_BAUD_921600 = 921600;
// Data Bits Selection
    FT_DATA_BITS_7 = 7;
    FT_DATA_BITS_8 = 8;
// Stop Bits Selection
    FT_STOP_BITS_1 = 0;
    FT_STOP_BITS_2 = 2;
// Parity Selection
    FT_PARITY_NONE = 0;
    FT_PARITY_ODD = 1;
    FT_PARITY_EVEN = 2;
    FT_PARITY_MARK = 3;
    FT_PARITY_SPACE = 4;
// Flow Control Selection
    FT_FLOW_NONE = $0000;
    FT_FLOW_RTS_CTS = $0100;
    FT_FLOW_DTR_DSR = $0200;
    FT_FLOW_XON_XOFF = $0400;
// Purge Commands
    FT_PURGE_RX = 1;
    FT_PURGE_TX = 2;

//************************************
  cCanSpeed: array [0..7,0..3,0..3] of Byte =(((49,0,5,7),(49,0,7,5),(49,2,7,3),(49,4,7,1)), {10Baud} {BRP,PRS,PHS1,PHS2}
                                              ((24,0,5,7),(24,0,7,5),(24,2,7,3),(24,4,7,1)), {20Baud}
                                              ((9,0,5,7),(9,0,7,5),(9,2,7,3),(9,4,7,1)),     {50Baud}
                                              ((4,0,5,7),(4,0,7,5),(4,2,7,3),(4,4,7,1)),     {100Baud}
                                              ((3,0,5,7),(3,0,7,5),(3,2,7,3),(3,4,7,1)),     {125Baud}
                                              ((1,0,5,7),(1,0,7,5),(1,2,7,3),(1,4,7,1)),     {250Baud}
                                              ((0,0,5,7),(0,0,7,5),(0,2,7,3),(0,4,7,1)),     {500Baud}
                                              ((0,0,1,3),(0,0,2,2),(0,0,3,1),(0,3,1,0)));    {1000Baud}


  //   0       1      2      3         4    5
  // START1,START2,CONTROL,LENGTH,DATA,END1,END2

  cSTART1=$FA;
  cSTART2=$F5;
  cEND1=$AF;
  cEND2=$5F;

  cPosSTART1=$00;
  cPosSTART2=$01;
  cPosCONTROL=$02;
  cPosLENGTH=$03;
  cPosData=$04;
  cPosCRC=$04;
  cPosEND1=$05;
  cPosEND2=$06;
  cMessLen=$07;

  cReady = $00;
  cInitCan =$01;		  // Initialization CAN driver
  cInitMC0_7 = $02;	  // Initialization MC0-MC7
  cInitMC8_14	=	$03;	// Initialization MC8-MC14
  cInitTime =	$04;		// Initialization Time
  cDisCan	 	=	$06;		// Disable CAN driver
  cDisMC0_7	=	$07;		// Disable M0 - MC7 (Receive)
  cDisMC8_14 = $08;	  // Disable M8 - MC14 (Tranceive)
  cPause		=	$0A;	  // Pause receive and transceive
  dRxCanToUSB = $0B;  // Receive Can Data
  dTxCanToUSB = $0C;  // Transceive Can Data
  dErrToUSB = $0D;    // Can Error

  cMaxFault=3;        // Maximum repeat request
  cTimeOut=4;         // Message timeout

// IO Buffer Sizes
    FT_In_Buffer_Size = $8000;    // 32k
    FT_In_Buffer_Index = FT_In_Buffer_Size - 1;

// IO Buffer Sizes
    FT_Out_Buffer_Size = $8000;    // 32k
    FT_Out_Buffer_Index = FT_Out_Buffer_Size - 1;
//**************************************

// DLL Name
    FT_DLL_Name = 'ftd2xx.dll';
var
// Declare Input and Output Buffers

   FT_In_Buffer : Array[0..FT_In_Buffer_Index] of byte;
   FT_Out_Buffer : Array[0..FT_Out_Buffer_Index] of byte;


// A variable used to detect time-outs
// Attach a timer to the main project form
// which decrements this every 10mS if
// FT_TimeOut_Count <> 0
   FT_TimeOut_Count : Integer = 0;
// Used to determine how many bytes were
// actually received by FT_Read_Device_All
// in the case of a time-out
   FT_All_Bytes_Received : Integer = 0;
   FT_IO_Status : Ft_Result = FT_OK;
// Used By FT_ListDevices
   FT_Device_Count : DWord;
   FT_Device_String_Buffer : Array [1..50] of Char;
   FT_Device_String : String;
   FT_Error_Count: Integer = 0;

//***********************************************
  Timer1: TTimer;
  onTimer: TonTimer; //SizeOf(TObj1) je zde 0

  Pause: Boolean;

  DevicePresent : Boolean;

  ZDataArray: array [0..255] of byte;
  ZTransfer: Boolean;
  ZTypeMessage: Integer;
  ZTimeOut: Integer;
  ZLenData: Integer;
  ZFault: Boolean;
  Zok: Boolean;

  NoPos: Integer;
  NoBuff: array [0..16383] of byte;

  MessBuff: array [0..255,0..255] of byte;
  MessPos: Integer;

//***********************************************

function FT_Open(PVDevice:Integer; ftHandle:Pointer ) : FT_Result ; stdcall ; External 'FTD2XX' name 'FT_Open';
function FT_Close(ftHandle:Dword) : FT_Result ; stdcall ; External 'FTD2XX' name 'FT_Close';
function FT_Read(ftHandle:Dword; FTInBuf : Pointer; BufferSize : LongInt; ResultPtr : Pointer ) : FT_Result ; stdcall ; External 'FTD2XX' name 'FT_Read';
function FT_Write(ftHandle:Dword; FTOutBuf : Pointer; BufferSize : LongInt; ResultPtr : Pointer ) : FT_Result ; stdcall ; External 'FTD2XX' name 'FT_Write';
function FT_SetBaudRate(ftHandle:Dword;BaudRate:DWord) : FT_Result ; stdcall ; External 'FTD2XX' name 'FT_SetBaudRate';
function FT_SetDataCharacteristics(ftHandle:Dword;WordLength,StopBits,Parity:Byte) : FT_Result ; stdcall ; External 'FTD2XX' name 'FT_SetDataCharacteristics';
function FT_SetFlowControl(ftHandle:Dword;FlowControl:Word;XonChar,XoffChar:Byte) : FT_Result ; stdcall ; External 'FTD2XX' name 'FT_SetFlowControl';
function FT_ResetDevice(ftHandle:Dword) : FT_Result ; stdcall ; External 'FTD2XX' name 'FT_ResetDevice';
function FT_SetDtr(ftHandle:Dword) : FT_Result ; stdcall ; External 'FTD2XX' name 'FT_SetDtr';
function FT_ClrDtr(ftHandle:Dword) : FT_Result ; stdcall ; External 'FTD2XX' name 'FT_ClrDtr';
function FT_SetRts(ftHandle:Dword) : FT_Result ; stdcall ; External 'FTD2XX' name 'FT_SetRts';
function FT_ClrRts(ftHandle:Dword) : FT_Result ; stdcall ; External 'FTD2XX' name 'FT_ClrRts';
function FT_GetModemStatus(ftHandle:Dword;ModemStatus:Pointer) : FT_Result ; stdcall ; External 'FTD2XX' name 'FT_GetModemStatus';
function FT_SetChars(ftHandle:Dword;EventChar,EventCharEnabled,ErrorChar,ErrorCharEnabled : Byte) : FT_Result ; stdcall ; External 'FTD2XX' name 'FT_SetChars';
function FT_Purge(ftHandle:Dword;Mask:Dword) : FT_Result ; stdcall ; External 'FTD2XX' name 'FT_Purge';
function FT_SetTimeouts(ftHandle:Dword;ReadTimeout,WriteTimeout:Dword) : FT_Result ; stdcall ; External 'FTD2XX' name 'FT_SetTimeouts';
function FT_GetQueueStatus(ftHandle:Dword;RxBytes:Pointer) : FT_Result ; stdcall ; External 'FTD2XX' name 'FT_GetQueueStatus';
function FT_GetNumDevices(pvArg1:Pointer;pvArg2:Pointer;dwFlags:Dword) : FT_Result ; stdcall ; External 'FTD2XX' name 'FT_ListDevices';
function FT_ListDevices(pvArg1:Dword;pvArg2:Pointer;dwFlags:Dword) : FT_Result ; stdcall ; External 'FTD2XX' name 'FT_ListDevices';
function FT_OpenEx(pvArg1:Pointer;dwFlags:Dword;ftHandle:Pointer) : FT_Result ; stdcall ; External 'FTD2XX' name 'FT_OpenEx';
function FT_GetStatus(ftHandle:Dword; RxBuffCount: Pointer; TxBuffCount: Pointer; DeviceState: Pointer) : FT_Result ; stdcall ; External 'FTD2XX' name 'FT_GetStatus';
function FT_SetEventNotification(ftHandle: Dword; dwEventMask: DWord; pvArg: Dword) : FT_Result ; stdcall ; External 'FTD2XX' name 'FT_SetEventNotification';


{$R *.res}

Procedure FT_Error_Report(ErrStr: String; PortStatus : Integer);
Var Str : String;
Begin
  Str:='';
  If Not FT_Enable_Error_Report then Exit;
  If PortStatus = FT_OK then Exit;
  Case PortStatus of
    FT_INVALID_HANDLE : Str := ErrStr+' - Invalid Handle...';
    FT_DEVICE_NOT_FOUND : Str := ErrStr+' - Device Not Found....';
    FT_DEVICE_NOT_OPENED : Str := ErrStr+' - Device Not Opened...';
    FT_IO_ERROR : Str := ErrStr+' - General IO Error...';
    FT_INSUFFICIENT_RESOURCES : Str := ErrStr+' - Insufficient Resources...';
    FT_INVALID_PARAMETER : Str := ErrStr+' - Invalid Parameter ...';
  End;
  if Length(Str)>0 then
  begin
    inc(FT_Error_Count);
  end;
End;

Function GetDeviceString : String;
Var I : Integer;
Begin
  Result := ''; I := 1;
  FT_Device_String_Buffer[50] := Chr(0); // Just in case !
  While FT_Device_String_Buffer[I] <> Chr(0) do
  Begin
    Result := Result + FT_Device_String_Buffer[I];
    Inc(I);
  End;
End;

Procedure SetDeviceString ( S : String );
Var I,L : Integer;
Begin
  FT_Device_String_Buffer[1] := Chr(0);
  L := Length(S);  If L > 49 then L := 49;
  If L = 0 then Exit;
  For I := 1 to L do FT_Device_String_Buffer[I] := S[I];
  FT_Device_String_Buffer[L+1] := Chr(0);
End;

Function GetFTDeviceCount : FT_Result; stdcall;
Begin
  Result := FT_GetNumDevices(@FT_Device_Count,Nil,FT_LIST_NUMBER_ONLY);
  If Result <> FT_OK then FT_Error_Report('GetFTDeviceCount',Result);
End;

Function GetFTDeviceSerialNo( DeviceIndex : DWord ) : FT_Result;
Begin
  Result := FT_ListDevices(DeviceIndex,@FT_Device_String_Buffer,(FT_OPEN_BY_SERIAL_NUMBER or FT_LIST_BY_INDEX));
  If Result = FT_OK then FT_Device_String := GetDeviceString;
  If Result <> FT_OK then FT_Error_Report('GetFTDeviceSerialNo',Result);
End;

Function GetFTDeviceDescription( DeviceIndex : DWord ) : FT_Result;
Begin
  Result := FT_ListDevices(DeviceIndex,@FT_Device_String_Buffer,(FT_OPEN_BY_DESCRIPTION or FT_LIST_BY_INDEX));
  If Result = FT_OK then FT_Device_String := GetDeviceString;
  If Result <> FT_OK then FT_Error_Report('GetFTDeviceDescription',Result);
End;

Function Open_USB_Device : FT_Result;
Begin
  Result := FT_Open(PV_Device,@FT_Handle);
  If Result <> FT_OK then FT_Error_Report('FT_Open',Result);
End;

Function Open_USB_Device_By_Serial_Number( Serial_Number : string ) : FT_Result;
Begin
  SetDeviceString(Serial_Number);
  Result := FT_OpenEx(@FT_Device_String_Buffer,FT_OPEN_BY_SERIAL_NUMBER,@FT_Handle);
  If Result <> FT_OK then FT_Error_Report('Open_USB_Device_By_Serial_Number',Result);
End;

Function Open_USB_Device_By_Device_Description( Device_Description : string ) : FT_Result;
Begin
  SetDeviceString(Device_Description);
  Result := FT_OpenEx(@FT_Device_String_Buffer,FT_OPEN_BY_DESCRIPTION,@FT_Handle);
  If Result <> FT_OK then FT_Error_Report('Open_USB_Device_By_Device_Description',Result);
End;

Function Close_USB_Device : FT_Result;
Begin
  Result :=  FT_Close(FT_Handle);
  If Result <> FT_OK then FT_Error_Report('FT_Close',Result);
End;

Function Reset_USB_Device : FT_Result;
Begin
  Result :=  FT_ResetDevice(FT_Handle);
  If Result <> FT_OK then FT_Error_Report('FT_ResetDevice',Result);
End;

Function Purge_USB_Device_Out : FT_Result;
Begin
  Result :=  FT_Purge(FT_Handle,FT_PURGE_TX);
  If Result <> FT_OK then FT_Error_Report('FT_Purge TX',Result);
End;

Function Purge_USB_Device_In : FT_Result;
Begin
  Result :=  FT_Purge(FT_Handle,FT_PURGE_RX);
  If Result <> FT_OK then FT_Error_Report('FT_Purge RX',Result);
End;

Function Set_USB_Device_RTS : FT_Result;
Begin
  Result :=  FT_SetRTS(FT_Handle);
  If Result <> FT_OK then FT_Error_Report('FT_SetRTS',Result);
End;

Function Clr_USB_Device_RTS : FT_Result;
Begin
  Result :=  FT_ClrRTS(FT_Handle);
  If Result <> FT_OK then FT_Error_Report('FT_ClrRTS',Result);
End;

Function Set_USB_Device_DTR : FT_Result;
Begin
  Result :=  FT_SetDTR(FT_Handle);
  If Result <> FT_OK then FT_Error_Report('FT_SetDTR',Result);
End;

Function Clr_USB_Device_DTR : FT_Result;
Begin
  Result :=  FT_ClrDTR(FT_Handle);
  If Result <> FT_OK then FT_Error_Report('FT_ClrDTR',Result);
End;

Function Set_USB_Device_BaudRate : FT_Result;
Begin
  Result :=  FT_SetBaudRate(FT_Handle,FT_Current_Baud);
  If Result <> FT_OK then FT_Error_Report('FT_SetBaudRate',Result);
End;

Function Set_USB_Device_DataCharacteristics : FT_Result;
Begin
  Result :=  FT_SetDataCharacteristics(FT_Handle,FT_Current_DataBits,FT_Current_StopBits,FT_Current_Parity);
  If Result <> FT_OK then FT_Error_Report('FT_SetDataCharacteristics',Result);
End;

Function Set_USB_Device_FlowControl : FT_Result;
Begin
  Result :=  FT_SetFlowControl(FT_Handle,FT_Current_FlowControl,FT_XON_Value,FT_XOFF_Value);
  If Result <> FT_OK then FT_Error_Report('FT_SetFlowControl',Result);
End;

Function Get_USB_Device_ModemStatus : FT_Result;
Begin
  Result :=  FT_GetModemStatus(FT_Handle,@FT_Modem_Status);
  If Result <> FT_OK then FT_Error_Report('FT_GetModemStatus',Result);
End;

Function Set_USB_Device_Chars : FT_Result;
Var Events_On,Errors_On : Byte;
Begin
  If FT_Event_On then Events_On := 1 else Events_On := 0;
  If FT_Error_On then Errors_On := 1 else Errors_On := 0;
  Result :=  FT_SetChars(FT_Handle,FT_EVENT_Value,Events_On,FT_ERROR_Value,Errors_On);
  If Result <> FT_OK then FT_Error_Report('FT_SetChars',Result);
End;

Function Set_USB_Device_TimeOuts(ReadTimeOut,WriteTimeOut:DWord) : FT_Result;
Begin
  Result :=  FT_SetTimeouts(FT_Handle,ReadTimeout,WriteTimeout);
  If Result <> FT_OK then FT_Error_Report('FT_SetTimeouts',Result);
End;

Function Get_USB_Device_QueueStatus : FT_Result;
Begin
  Result :=  FT_GetQueueStatus(FT_Handle,@FT_Q_Bytes);
  If Result <> FT_OK then FT_Error_Report('FT_GetQueueStatus',Result);
End;

// Writes Write_Count Bytes from FT_Out_Buffer to the USB device
// Function returns the number of bytes actually sent
// In this example, Write_Count should be 32k bytes max
function Write_USB_Device_Buffer( Write_Count : Integer ) : Integer;
Var Write_Result : Integer;
Begin
  FT_IO_Status := FT_Write(FT_Handle,@FT_Out_Buffer,Write_Count,@Write_Result);
  If FT_IO_Status <> FT_OK then FT_Error_Report('FT_Write',FT_IO_Status);
  Result := Write_Result;
End;

// Reads Read_Count Bytes ( or less ) from the USB device to the FT_In_Buffer
// Function returns the number of bytes actually received  which may range from zero
// to the actual number of bytes requested, depending on how many have been received
// at the time of the request + the read timeout value.
function Read_USB_Device_Buffer( Read_Count : Integer ) : Integer;
Var Read_Result : Integer;
Begin
  FT_IO_Status := FT_Read(FT_Handle,@FT_In_Buffer,Read_Count,@Read_Result);
  If FT_IO_Status <> FT_OK then FT_Error_Report('FT_Read',FT_IO_Status);
  Result := Read_Result;
End;

function GetRxDataCount: Integer;
Var RxCount, TxCount, DeviceState: Integer;
Begin
  FT_IO_Status := FT_GetStatus(FT_Handle,@RxCount,@TxCount,@DeviceState);
  If FT_IO_Status <> FT_OK then FT_Error_Report('FT_Status',FT_IO_Status);
  Result := RxCount;
End;

function GetTxDataCount: Integer;
Var RxCount, TxCount, DeviceState: Integer;
Begin
  FT_IO_Status := FT_GetStatus(FT_Handle,@RxCount,@TxCount,@DeviceState);
  If FT_IO_Status <> FT_OK then FT_Error_Report('FT_Status',FT_IO_Status);
  Result := TxCount;
End;

function SetEventNotification(dwEventMask: DWord; pvArg: Dword): Boolean;
Begin
  FT_SetEventNotification(FT_Handle,dwEventMask,pvArg);
  Result:=False;
End;

//*******************************************
// Decode ID from procesor Register IDT1,IDT2,IDT3,IDT4,CONCH
function DecodeID(CAN_A: Boolean; IDT1,IDT2,IDT3,IDT4,CONCH: Integer; var RTR, IDE: Boolean): Integer;
begin
  IDE:=(CONCH and $10 = $10);
  if not IDE then result:=(IDT1 shl 3)+(IDT2 shr 5)
  else result:=(IDT1 shl 21)+(IDT2 shl 13)+(IDT3 shl 5)+(IDT4 shr 3);
  RTR := ((IDT4 and $04) = $04);
end;

// Code ID for procesor Register IDT1,IDT2,IDT3,IDT4
procedure CodeID(CAN_2_0A: Boolean; ID: Integer; RTR: Boolean; var IDT1,IDT2,IDT3,IDT4: Integer);
begin
  if CAN_2_0A then
  begin
    IDT1:=((ID and $7F8) shr 3);
    IDT2:=((ID and $007) shl 5);
    IDT3:=0;
    IDT4:=0;
  end
  else
  begin
    IDT1:=((ID and $1FE00000) shr 21);
    IDT2:=((ID and $001FE000) shr 13);
    IDT3:=((ID and $00001FE0) shr 5);
    IDT4:=((ID and $0000001F) shl 3);
  end;
  if RTR then IDT4:=IDT4 + $04;
end;

// Calculate CRC
function CRC(Pole: array of Byte; StartPoz, StopPoz: Integer): Byte; // private function
var CRCx, x: Byte;
begin
  CRCx:=0;
  for x:=StartPoz to StopPoz do
  begin
    CRCx:=CRCx xor Pole[x];
  end;
  result:=CRCx;
end;

// Test valid time
function TestTime(Hour, Min, Sec, Msec: Integer): Boolean; // private function
begin
  result:=(Hour<24)and(Min<60)and(Sec<60)and(Msec<1000);
end;

// Receive Message Show
// Hour,Min,Sec,Msec ... Receive Message Time [0..23],[0..59],[0..59],[0.999]
// RTR .... Transmit Data Frame(RTR=False)/Remote Frame(RTR=True)
// ID  .... CAN idetifier
// Count .. Receive Data Count
// bData .. Receive Data byte array
procedure ReceiveCanData(var Hour,Min,Sec,Msec: Integer; var RTR: Boolean; var ID,Count: Integer; var Data: array of Byte);
begin
{  lblTime.Caption:=sDecodeTime(Hour,Min,Sec,Msec);
  lblID.Caption:=IntToHex(ID,8);
  lblData.Caption:=sDecodeData(Data,Count);
}end;

// Decode All message
// Test procesor Message (Start and CRC code)
// Flow Control (Receive Frame, Receive Error, Receive Acknowledgment)
procedure DecodeMessage(var Data: array of Byte; var fMessType, fHour, fMin, fSec, fMsec, fID, fCountData: Integer; var fRTR, fIDE: Boolean); stdcall;
var Hour, Min, Sec, Msec, ID, CountData, x: Integer;
    RTR,IDE: Boolean;
    CAN_2_0A: Boolean;
begin
  CAN_2_0A:= True;
  // Test Start1,Start2,CRC
  if(Data[cPosSTART1]=$FA)and(Data[cPosSTART2]=$F5)and((CRC(Data,cPosCONTROL,Data[cPosLENGTH]+cPosCRC)=0))then
  begin
    fMessType:=Data[cPosCONTROL];
    // Flow Control
    case fMessType of
      // Show Receive Frame
      dRxCanToUSB, dTxCanToUSB:
      begin
        if not Pause then
        begin
          Hour:=Data[5];
          Min:=Data[6];
          Sec:=Data[7];
          MSec:=256*Data[8]+Data[9];
          // Test Valid Time
          if TestTime(Hour,Min,Sec,Msec)then
          begin         // CANIDT1, CANIDT2, CANIDT3, CANIDT4, CONCH
            ID:= DecodeID(CAN_2_0A, Data[10],Data[11],Data[12],Data[13],Data[14],RTR,IDE);
            CountData:=Data[14];
            for x:=0 to 7 do Data[x]:=Data[15+x]; // Receive Data
            // Show receive message

            fHour:= Hour;
            fMin:= Min;
            fSec:= Sec;
            fMsec:= Msec;
            fID:= ID;
            fCountData:= CountData;
            fRTR:= RTR;
            fIDE:= IDE;
          end;
        end;
      end;
      // Show CAN Errors
      dErrToUSB:
      begin
        Data[0]:=Data[cPosData];
      end
      // Show Acknowledgment
      else Data[0]:=Data[cPosCONTROL];
    end;
  end;
end;

procedure Delay(ms : LongWord);
var kdy : LongWord;
begin
 kdy := GetTickCount + ms;
 while GetTickCount < kdy do Application.ProcessMessages;
end;

// Create messages for transfer data
function CreateMessage(TypeMessage, LenData: Integer; DataArray: array of Byte): Boolean;
var x: Integer;
begin
  if DevicePresent then
  begin
    FT_Enable_Error_Report := True;   // Enable Error Reporting
    Timer1.Enabled := False;          // Stop Polling for Device Present
    ZTransfer:=True;                  // Will be data transfer
    if(LenData>32)then LenData:=32;   // Test Len
    ZLenData:=LenData;                // Save Len
    ZTypeMessage:=TypeMessage;        // Message type
    ZFault:=False;                    // Fault
    Zok:=False;                       // Receive
    ZTimeOut:=cTimeOut;               // Message TimeOut
    FT_Out_Buffer[cPosSTART1] := cStart1;
    FT_Out_Buffer[cPosSTART2] := cStart2;
    FT_Out_Buffer[cPosCONTROL] := TypeMessage;
    FT_Out_Buffer[cPosLENGTH] := LenData;
    for x:=0 to LenData-1 do ZDataArray[x]:=DataArray[x];
    for x:=0 to LenData-1 do FT_Out_Buffer[cPosData+x]:=DataArray[x];
    FT_Out_Buffer[cPosCRC+LenData]  := CRC(FT_Out_Buffer,cPosCONTROL,cPosCRC+LenData-1);
    FT_Out_Buffer[cPosEND1+LenData] := cEnd1;
    FT_Out_Buffer[cPosEND2+LenData] := cEnd2;
    x := Write_USB_Device_Buffer(cMessLen+LenData);
    Timer1.Enabled := True;           // Resume Polling for Device Present
    result := (x = cMessLen+LenData);
  end
  else result:=False;
end;

// Stop transmit data
// MCx = Message Centrum [0..7]
procedure DisableMC(MCx: Integer); stdcall;
var Data: array [0..255] of byte;
begin
  if DevicePresent then
  begin
    // MCx = Message Centrum [0..7]
    Data[0]:=MCx;         // MCx
    CreateMessage(cDisMC8_14,$01,Data);
  end
  else Application.MessageBox('Device Not Present! You must Plug-In USB Adaptor or '+#13#10+'Instal USB Driver and Restart your Computer.','Warning',MB_Ok+MB_ICONWARNING);
end;


// Disable transmit data
procedure DisableMCAll; stdcall;
begin
  if DevicePresent then
  begin
    // Stop Transmit Data in Message Centrum 0..7
    DisableMC(0);
    DisableMC(1);
    DisableMC(2);
    DisableMC(3);
    DisableMC(4);
    DisableMC(5);
    DisableMC(6);
    DisableMC(7);
  end;
end;

// Setting processor Register CANBT1,CANBT2,CANBT3 a CANCONCH
// Communication Speed
// Listening mode
procedure GetCANBTx(SpeedIndex: Integer; ListeningMod: Boolean; var CANBT1,CANBT2,CANBT3,CANGCON: Byte);
const PosIndex=1;  // 67,5%
begin
  if SpeedIndex <0 then SpeedIndex:=5;
  CANBT1:= cCanSpeed[SpeedIndex][PosIndex][0] shl 1;        // BRP
  CANBT2:= cCanSpeed[SpeedIndex][PosIndex][1] shl 1;        // PRS
  CANBT3:= 0;                                               // SMP
  CANBT3:= CANBT3+cCanSpeed[SpeedIndex][PosIndex][2] shl 1; // PHS1
  CANBT3:= CANBT3+cCanSpeed[SpeedIndex][PosIndex][3] shl 4; // PHS2
  if ListeningMod then
  begin
    CANGCON:=$0A;          // Listening Mode and Autobaude
    DisableMCAll;
    Delay(100);
  end
  else
  begin
    CANGCON:=$02;
  end;
end;

function Hex(znak: char): Integer;
begin
 znak:=upcase(znak);
 case znak of
  '0'..'9': Hex := ord(znak)-ord('0');
  'A': Hex := 10;
  'B': Hex := 11;
  'C': Hex := 12;
  'D': Hex := 13;
  'E': Hex := 14;
  'F': Hex := 15;
  else Hex := 0;
 end;
end;

// Convert Hex to Integer
function HexToInt(Num: string): Integer;
var Len, Suma, x: Integer;
begin
  Suma:=0;
  Len:=Length(Num);
  for x:=1 to Len do Suma:=16*Suma+Hex(Num[x]);
  result:=Suma;
end;

function DriverSpeed(HighSpeed: Boolean): Integer;
begin
  if HighSpeed then result:=$00
  else result:=$01;
end;

// Main initialize CAN link
// Test Ready
// Set time from actual time your PC
// Initialize Global Register Driver
// Initialize Receive Message Center
procedure InitCan(HighSpeed: Boolean; SpeedIndex: Integer; ListeningMod: Boolean; CAN_2_0A: Boolean; Tag, Mask: String); stdcall;
var CANBT1,CANBT2,CANBT3,CANGCON: Byte;
    Data: array [0..255] of byte;
    Hour, Min, Sec, MSec: Word;
    ID1,ID2,ID3,ID4,IM1,IM2,IM3,IM4,CONCH: Integer;
begin
  if DevicePresent then
  begin
    // Test Ready
    CreateMessage(cReady,$00,Data);
    Delay(100);

    // Set time from actual time your PC
    DecodeTime(Now, Hour, Min, Sec, MSec);
    Data[0]:=Hour;
    Data[1]:=Min;
    Data[2]:=Sec;
    Data[3]:=Msec div 256;
    Data[4]:=Msec mod 256;
    CreateMessage(cInitTime,$05,Data);
    Delay(100);

    // Initialize Global Register Driver
    GetCANBTx(SpeedIndex, ListeningMod, CANBT1,CANBT2,CANBT3,CANGCON);
    Data[0]:=CANBT1;  // CANBT1
    Data[1]:=CANBT2;  // CANBT2
    Data[2]:=CANBT3;  // CANBT3
    Data[3]:=CANGCON; // CANGCON
    Data[4]:=$32;     // CANGIE
    Data[5]:=DriverSpeed(HighSpeed);
    CreateMessage(cInitCAN,$06,Data);
    Delay(100);

    // Initialize Receive Message Center
    CodeID(CAN_2_0A, HexToInt(Tag),FALSE,ID1,ID2,ID3,ID4);
    CodeID(CAN_2_0A, HexToInt(Mask),FALSE,IM1,IM2,IM3,IM4);
    if CAN_2_0A then CONCH:=$08 else CONCH:=$18;

    Data[0]:=$00;    // MCx [0..6]
    Data[1]:=ID1;    // CANIDT1
    Data[2]:=ID2;    // CANIDT2
    Data[3]:=ID3;    // CANIDT3
    Data[4]:=ID4;    // CANIDT4
    Data[5]:=IM1;    // CANIDM1
    Data[6]:=IM2;    // CANIDM2
    Data[7]:=IM3;    // CANIDM3
    Data[8]:=IM4;    // CANIDM4
    Data[9]:=CONCH;  // CANCONCH (2.0A/2.0B + Length)
    CreateMessage(cInitMC0_7,$0A,Data);

    Pause:=False;
  end
  else Application.MessageBox('Device Not Present! You must Plug-In USB Adaptor or '+#13#10+'Instal USB Driver and Restart your Computer.','Warning',MB_Ok+MB_ICONWARNING);
end;

// Main Disable CAN link
// Disable Transmit MC
// Disable Receive MC
// Disable CAN driver
procedure DisableCan; stdcall;
var Data: array [0..255] of byte;
begin
  if DevicePresent then
  begin
    // MCx Disable Transmit (0..7) [0..7]
    DisableMCAll;
    Delay(100);

    // MCx Disable Receive (0) [0..6]
    Data[0]:=0;
    CreateMessage(cDisMC0_7,$01,Data);
    Delay(100);

    // Disable Global Register
    CreateMessage(cDisCAN,$0,Data);
    Delay(100);
   Pause := False;
  end
  else Application.MessageBox('Device Not Present! You must Plug-In USB Adaptor or '+#13#10+'Instal USB Driver and Restart your Computer.','Warning',MB_Ok+MB_ICONWARNING);
end;

// Data Transmit to CAN link
// MCx .... Message Center [0..7]
// Per .... Transmit Periode(Delay) [0..65525][ms]
// Sys .... Transmit Mode (1..One Transmit (time delay = per[ms]), 3..Periodic Transmit (period = per[ms]), 4..Imediately Transmit (no time delay), All + 8 .. Receive Transmit Frame
// RTR .... Transmit Data Frame(RTR=False)/Remote Frame(RTR=True)
// ID  .... CAN idetifier
// Count .. Transmit Data Count
// bData .. Transmit Data byte array
procedure TransmitCanData(CAN_2_0A: Boolean; MCx,Per,Sys: Integer; RTR: Boolean; ID,Count: Integer; bData: array of Byte); stdcall;
var Data: array [0..255] of byte;
    ID1,ID2,ID3,ID4,CONCH,x:Integer;
begin    // RTR=True -> Remote FRAME
  if CAN_2_0A then CONCH:=$00 else CONCH:=$10;
  CodeID(CAN_2_0A, ID,RTR,ID1,ID2,ID3,ID4);
  // Transmit CAN data
  Data[0]:=MCx;         // MCx  [0..7]
  Data[1]:=Per div 256; // PerH [0..65535]
  Data[2]:=Per mod 256; // PerL
  Data[3]:=Sys;         // Sys  1..One Transmit (time delay = per[ms]), 3..Periodic Transmit (period = per[ms]), 4..Imediately Transmit (no time delay), +8..Receive transmit Frame
  Data[4]:=ID1;         // ID1
  Data[5]:=ID2;         // ID2
  Data[6]:=ID3;         // ID3
  Data[7]:=ID4;         // ID4
  Data[8]:=CONCH+Count; // Length
  for x:=0 to Count-1 do Data[9+x]:=bData[x];
  CreateMessage(cInitMC8_14,$11,Data);
end;

// Pause On/Off
procedure SetPause(State: Boolean); stdcall;
var Data: array [0..255] of byte;
begin
  if DevicePresent then
  begin
    Pause := State;
    if Pause then Data[0]:=$FF
    else Data[0]:=0;
    CreateMessage(cPause,$01,Data);
  end
  else Application.MessageBox('Device Not Present! You must Plug-In USB Adaptor or '+#13#10+'Instal USB Driver and Restart your Computer.','Warning',MB_Ok+MB_ICONWARNING);
end;

// Multiple open Adaptors to single PC
function Open_USB_Adaptor: FT_Result;
var Serial_Number: string;
    DeviceCount: Integer;
    DeviceIndex: DWord;
begin
  result:=FT_NONE;
  GetFTDeviceCount;
  DeviceCount:=FT_Device_Count;
  if FT_Device_Count > 0 then
  begin
    for DeviceIndex:=0 to DeviceCount-1 do
    begin
      GetFTDeviceSerialNo(DeviceIndex);
      Serial_Number:=FT_Device_String;
      result:=Open_USB_Device_By_Serial_Number(Serial_Number);
      if result = FT_OK then break;
    end;
  end;
end;


// Message identfication
function MessIdent(var MessData: array of Byte; var MessDetect: array of Byte; var ActPos, NoPos: Integer; Length: Integer): Boolean;
var x,Len: Integer;
begin
  NoPos:=0;
  // Finding messages (start1,star2,direction,length,data,end1,end2)
  while((MessData[ActPos+cPosSTART1]<>cSTART1)or(MessData[ActPos+cPosSTART2]<>cSTART2)or
       (MessData[ActPos+MessData[ActPos+cPosLENGTH]+cPosEND1]<>cEND1)or
       (MessData[ActPos+MessData[ActPos+cPosLENGTH]+cPosEND2]<>cEND2))and(ActPos<Length)do
  begin
    inc(ActPos);
    inc(NoPos);
  end;
  // Get length message
  Len:=MessData[ActPos+cPosLENGTH];
  // It's true finding?
  if(ActPos<Length)then
  begin
    for x:= 0 to cMessLen+Len-1 do MessDetect[x]:=MessData[ActPos+x];
    ActPos:= ActPos+cMessLen+Len;
    NoPos:= 0;
    result:= True;
  end
  else result:= False;
end;

// Separate Save messages
procedure SaveMessage(var MessData: array of Byte; Length: Integer);
var x,ActPos: Integer;
    TempData: array [0..65535] of Byte;
    MessDetect: array [0..255] of Byte;
begin
  ActPos:=0;
  if NoPos>1000 then NoPos:=0;
  for x:=0 to NoPos do TempData[x]:=NoBuff[x];
  for x:=0 to Length-1 do TempData[x+NoPos+1]:=MessData[x];
  Length:=Length+NoPos;
  while MessIdent(TempData,MessDetect,ActPos,NoPos,Length) do
  begin
    for x:=0 to 255 do MessBuff[MessPos][x]:=MessDetect[x];
    Inc(MessPos);
  end;
  if NoPos>0 then
  begin
    for x:=0 to NoPos do NoBuff[x]:=TempData[Length-NoPos+x];
  end;
end;

// Separate Get messages
function GetMessage(var MessData: array of Byte): Boolean; stdcall;
var x,y: Integer;
begin
  if MessPos>0 then
  begin
    for x:=0 to 255 do MessData[x]:=MessBuff[0][x];
    for y:=0 to MessPos-1 do
    begin
      for x:=0 to 255 do MessBuff[y][x]:=MessBuff[y+1][x];
    end;
    Dec(MessPos);
    result:=True;
  end
  else result:=False;
end;

procedure SendMessage;
var
  wParam: Integer;
  FormPointer: THandle;
  FormName: PAnsichar;
begin
  FormName:= 'TfrmMain';
  FormPointer := FindWindow(FormName,nil);
  wParam := 1;
  PostMessage(FormPointer, WM_USER + 123, wParam,0);
end;

// Receive Data Execute
procedure FTReceiveFileExecute;
var I : Integer;
begin
  FT_Enable_Error_Report := False;  // Disable Error Reporting
  Timer1.Enabled := False;          // Stop Polling for Device Present
  I := Read_USB_Device_Buffer(FT_In_Buffer_Size);
  SaveMessage(FT_In_Buffer,I);

  SendMessage;
end;

// Call from procedure onTime (55ms)
procedure ReceiveData(Index: Integer);
begin
  if DevicePresent then
  begin
    if GetRxDataCount>0 then
    begin
      FTReceiveFileExecute;
    end;
  end;
end;

// Timer for device detect T=55ms
procedure TonTimer.OnTimer(o: TObject);
var PortStatus : FT_Result;
begin
  FT_Enable_Error_Report := False; // Turn off error dialog
  If Not DevicePresent then
  begin
    PortStatus := Close_USB_Device; // In case device was already open
    PortStatus := Open_USB_Adaptor; // Try and open device (Open_USB_Device)
    If PortStatus = FT_OK then      // Device is Now Present !
    begin
      DevicePresent := True;
      Reset_USB_Device;     // warning - this will destroy any pending data.
      Set_USB_Device_TimeOuts(100,100); // read and write timeouts = 10mS [1..500][ms]
    end;  // IBN
  end
  else
  begin
    PortStatus := Get_USB_Device_QueueStatus;
    If PortStatus <> FT_OK then
    begin   // Device has been Unplugged
      DevicePresent := False;
    end;
    ReceiveData(1); //if GetRxDataCount>0 then FTReceiveFileExecute(Self);
  end;
end;

///////////////////////////////////////
///////////////////////////////////////

// Message detection
function MessPresent(var MessData: array of Byte; Length: Integer): Boolean;
begin
  if(MessData[cPosLENGTH]+cMessLen)>=Length then result:=True else result:=False;
end;

// USB Driver Close
procedure FTQuitExecute;
begin
  If DevicePresent then Close_USB_Device;
end;

procedure EnableTimer; stdcall;
begin
  Timer1.Enabled:= True;
end;

exports
  DisableCan, InitCan, TransmitCanData, DisableMC, DisableMCAll, SetPause, EnableTimer,
  GetMessage, DecodeMessage;

begin

  MessPos:= 0;
  NoPos:= 0;

//**********************************
  DevicePresent := False;

  Timer1:= TTimer.Create(nil);
  Timer1.OnTimer := onTimer.OnTimer;

  Timer1.Interval := 55;
  Timer1.Enabled := True;
end.
